/**
 * Title:        Experiment 2
 * Description:  This experiment is to test how to use stored procedure to reduce communication between server and client.
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author Hui Wan
 * @version 1.0
 */

/*This class is to rebuild database*/
import java.sql.*;
import java.util.*;

public class ClearClass{
//public class ClearClass {
  long transStartTime;      // transaction start time
  long transEndTime;        // transaction end time
  long transResponseTime;    // transaction response time
  static float max = 30000;

  Statement stmt;
  CallableStatement spstmt;
  Vector resultString ;

  public int Clear(Connection con) {
    // get start time
    transStartTime = System.currentTimeMillis();

    resultString = new Vector();
    try
    {
        int suc, i=0;

        con.setAutoCommit(false);
        stmt = con.createStatement();
        stmt.executeUpdate("set chained off");
        spstmt = con.prepareCall("{call Rebuild_proc(?)}");
        spstmt.registerOutParameter(1, java.sql.Types.INTEGER);
        spstmt.executeUpdate();
        con.setAutoCommit(true);
    }  //end of try
    catch (SQLException sqle)
    {
        CloseQuery(spstmt, con);
        if (sqle.getErrorCode()==1205)        //Sybase deadlock error code
        {
            return -5;                     //deadlock error code specified in TPPT
        }
        String output = new String("ClearClass.Clear: Failed.\n");
        resultString.addElement(output);
        System.out.print(output);
        System.out.print(sqle.getMessage());

        return -2;     //other SQLexceptions error code
    }  //end of catch

    transEndTime = System.currentTimeMillis(); // get end time
    transResponseTime = transEndTime - transStartTime;  // get response time

    System.out.println(transResponseTime);
    return (int)transResponseTime;  // return response time if successful
  }//end of method Clear

 public boolean CloseQuery(Statement stmt, Connection con)
 {
 // performs routine checks when closing a query
    try
    {
         stmt.close();
         con.rollback();
         con.setAutoCommit(true);
    }  //end of try

    catch (SQLException sqle)
    {
        return false;
    }  //end of catch
     return true;
 }//end of method CloseQuery

 // returning infomation to TPPT
 public String[] OutputResult()
 {
     return (String[])resultString.toArray();
 }
}